/********************************************************************
 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *******************************************************************/

/** INCLUDES *******************************************************/
#include "system.h"

#include <stdint.h>
#include <string.h>
#include <stddef.h>

#include "usb.h"

//#include <app_led_usb_status.h>
#include "app_device_cdc_basic.h"
#include "usb_config.h"

#include <stdlib.h>
#include <stdio.h>
//#include <string.h>

/** VARIABLES ******************************************************/

//static bool buttonPressed;
static char buttonMessage[] = "Button pressed.\r\n";
static uint8_t readBuffer[CDC_DATA_OUT_EP_SIZE];//=64
static uint8_t writeBuffer[CDC_DATA_IN_EP_SIZE];//=64

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoInitialize(void);
*
* Overview: Initializes the demo code
*
* PreCondition: None
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCDCBasicDemoInitialize()
{
    CDCInitEP();

    
    line_coding.bCharFormat = 0;
    line_coding.bDataBits = 8;
    line_coding.bParityType = 0;
    line_coding.dwDTERate = 9600;

    //buttonPressed = false;

    
}

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoTasks(void);
*
* Overview: Keeps the demo running.
*
* PreCondition: The demo should have been initialized and started via
*   the APP_DeviceCDCBasicDemoInitialize() and APP_DeviceCDCBasicDemoStart() demos
*   respectively.
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCDCBasicDemoTasks()
{

    /*if(BUTTON_IsPressed(BUTTON_DEVICE_CDC_BASIC_DEMO) == true)
    {

        if(buttonPressed == false)
        {

            if(mUSBUSARTIsTxTrfReady() == true)
            {
                putrsUSBUSART(buttonMessage);
                buttonPressed = true;
            }
        }
    }
    else
    {

        buttonPressed = false;
    }*/

    /* Check to see if there is a transmission in progress, if there isn't, then
     * we can see about performing an echo response to data received.
     */
    if( USBUSARTIsTxTrfReady() == true)
    {
        uint8_t i;
        uint8_t numBytesRead;

        numBytesRead = getsUSBUSART(readBuffer, sizeof(readBuffer));

        /* For every byte that was read... */
        for(i=0; i<numBytesRead; i++)
        {
            switch(readBuffer[i])
            {
                /* If we receive new line or line feed commands, just echo
                 * them direct.
                 */
                case 0x0A:
                case 0x0D:
                    writeBuffer[i] = readBuffer[i];
                    break;

                /* If we receive something else, then echo it plus one
                 * so that if we receive 'a', we echo 'b' so that the
                 * user knows that it isn't the echo enabled on their
                 * terminal program.
                 */
                default:
                    writeBuffer[i] = readBuffer[i] + 1;
                    break;
            }
        }

        if(numBytesRead > 0)
        {
            /* After processing all of the received data, we need to send out
             * the "echo" data now.
             */
            putUSBUSART(writeBuffer,numBytesRead);
        }
    }

    CDCTxService();
}

void MyCDCBasicTasks()
{
    if( USBUSARTIsTxTrfReady() == true)
    {
        uint8_t i,j,k;
        uint8_t numBytesRead;
        unsigned char FIN[5][20];

        double X1,X2,X3;

        numBytesRead = getsUSBUSART(readBuffer, sizeof(readBuffer));

        if(numBytesRead > 0)
        {
            j=0;k=0;
            for(i=0;i<numBytesRead;i++)
            {
                if(readBuffer[i] == '#')
                {
                    FIN[j][k]=0;
                    j++;
                    if(j>5){j=4;}
                    k=0;
                }
                else
                {
                    FIN[j][k]=readBuffer[i];
                    k++;if(k>20){k=19;}
                }
            }
            int TEST=1;
            if(FIN[0][0]=='A' && FIN[0][1]=='A' && FIN[0][2]==0)
            {
                X1=atof((const char *)FIN[1]);
                X2=atof((const char *)FIN[2]);
                X3=X1+X2;

                sprintf(writeBuffer,"%.2f + %.2f = %.2f\r\n",X1,X2,X3);
                numBytesRead = strlen(writeBuffer);
                putUSBUSART(writeBuffer,numBytesRead);
                TEST=2;
            }
        }
    }
    CDCTxService();
}